/* SMTSIM simulator.
   
   Copyright (C) 1994-1999 by Dean Tullsen (tullsen@cs.ucsd.edu)
   ALL RIGHTS RESERVED.

   SMTSIM is distributed under the following conditions:

     You may make copies of SMTSIM for your own use and modify those copies.

     All copies of SMTSIM must retain all copyright notices contained within.

     You may not sell SMTSIM or distribute SMTSIM in conjunction with a
     commerical product or service without the express written consent of
     Dean Tullsen.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.

Significant parts of the SMTSIM simulator were written by Gun Sirer
(before it became the SMTSIM simulator) and by Jack Lo (after it became
the SMTSIM simulator).  Therefore the following copyrights may also apply:

Copyright (C) Jack Lo
Copyright (C) E. Gun Sirer

Pieces of this code may have been derived from Jim Larus' SPIM simulator,
which contains the following copyright:

==============================================================
   Copyright (C) 1990-1998 by James Larus (larus@cs.wisc.edu).
   ALL RIGHTS RESERVED.

   SPIM is distributed under the following conditions:

     You may make copies of SPIM for your own use and modify those copies.

     All copies of SPIM must retain my name and copyright notice.

     You may not sell SPIM or distributed SPIM in conjunction with a
     commerical product or service without the expressed written consent of
     James Larus.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.
===============================================================
 */

void emulate_unimplemented_instruction();
void emulate_invalid_instruction();
void emulate_nop();

void emulate_lda();
void emulate_ldah();
void emulate_ldq_u();
void emulate_stq_u();

void emulate_inta_addl();
void emulate_inta_addq();
void emulate_inta_cmple();
void emulate_inta_cmpult();
void emulate_inta_s4addl();
void emulate_inta_s4subq();
void emulate_inta_s8subl();
void emulate_inta_cmpbge();
void emulate_inta_cmplt();
void emulate_inta_subl();
void emulate_inta_subq();
void emulate_inta_s4addq();
void emulate_inta_s8addl();
void emulate_inta_s8subq();
void emulate_inta_cmpeq();
void emulate_inta_cmpule();
void emulate_inta_s4subl();
void emulate_inta_s8addq();

void emulate_intl_and();
void emulate_intl_bic();
void emulate_intl_bis_smt_fork();
void emulate_intl_bis_smt_join();
void emulate_intl_bis_smt_getid();
void emulate_intl_bis_smt_createstack();
void emulate_intl_bis_smt_hw_lock();
void emulate_intl_bis_smt_wait();
void emulate_intl_bis_smt_release();
void emulate_intl_bis_smt_release_and_wait();
void emulate_intl_bis_smt_release_all();
void emulate_intl_bis_smt_terminate();
void emulate_intl_bis_smt_stop();
void emulate_intl_bis_smt_start_sim();
void emulate_intl_bis_smt_print_sim();
void emulate_intl_bis_smt_end_sim();
void emulate_intl_bis_smt_unimplemented();
void emulate_intl_bis_smt_tas();
void emulate_intl_bis_smt_clear_and_stop();
void emulate_intl_bis_smt_restart();
void emulate_intl_cmoveq();
void emulate_intl_cmovlbc();
void emulate_intl_cmovlbs();
void emulate_intl_cmovge();
void emulate_intl_cmovgt();
void emulate_intl_cmovle();
void emulate_intl_cmovlt();
void emulate_intl_cmovne();
void emulate_intl_eqv();
void emulate_intl_ornot();
void emulate_intl_xor();

void emulate_ints_extbl();
void emulate_ints_extlh();
void emulate_ints_extll();
void emulate_ints_extqh();
void emulate_ints_extql();
void emulate_ints_extwh();
void emulate_ints_extwl();
void emulate_ints_insbl();
void emulate_ints_inslh();
void emulate_ints_insll();
void emulate_ints_insqh();
void emulate_ints_insql();
void emulate_ints_inswh();
void emulate_ints_inswl();
void emulate_ints_mskbl();
void emulate_ints_msklh();
void emulate_ints_mskll();
void emulate_ints_mskqh();
void emulate_ints_mskql();
void emulate_ints_mskwh();
void emulate_ints_mskwl();
void emulate_ints_sll();
void emulate_ints_sra();
void emulate_ints_srl();
void emulate_ints_zap();
void emulate_ints_zapnot();

void emulate_intm_mull();
void emulate_intm_mulq();
void emulate_intm_umulh();

void emulate_fltl_cpys();
void emulate_fltl_cpyse();
void emulate_fltl_cpysn();
void emulate_fltl_cvtlq();
void emulate_fltl_cvtql();
void emulate_fltl_fcmoveq();
void emulate_fltl_fcmovge();
void emulate_fltl_fcmovgt();
void emulate_fltl_fcmovle();
void emulate_fltl_fcmovlt();
void emulate_fltl_fcmovne();
void emulate_fltl_mt_fpcr();
void emulate_fltl_mf_fpcr();

void emulate_flti_add();
void emulate_flti_cmpteq();
void emulate_flti_cmptlt();
void emulate_flti_cmptle();
void emulate_flti_cvtq();
void emulate_flti_cvtts();
void emulate_flti_divs();
void emulate_flti_divt();
void emulate_flti_mul();
void emulate_flti_sub();
void emulate_flti_cvttq();

void emulate_jmp();
void emulate_jsr();
void emulate_retn();
void emulate_jsr_coroutine();
void emulate_lds();
void emulate_ldt();
void emulate_sts();
void emulate_stt();
void emulate_ldl();
void emulate_ldq();
void emulate_ldl_l();
void emulate_ldq_l();
void emulate_stl();
void emulate_stq();
void emulate_stl_c();
void emulate_stq_c();
void emulate_bsr();
void emulate_br();
void emulate_fbeq();
void emulate_fblt();
void emulate_fble();
void emulate_fbne();
void emulate_fbge();
void emulate_fbgt();
void emulate_blbc();
void emulate_beq();
void emulate_blt();
void emulate_ble();
void emulate_blbs();
void emulate_bne();
void emulate_bge();
void emulate_bgt();

void emulate_call_pal_callsys();
void emulate_call_pal_rduniq();
void emulate_call_pal_wruniq();

