/* SMTSIM simulator.
   
   Copyright (C) 1994-1999 by Dean Tullsen (tullsen@cs.ucsd.edu)
   ALL RIGHTS RESERVED.

   SMTSIM is distributed under the following conditions:

     You may make copies of SMTSIM for your own use and modify those copies.

     All copies of SMTSIM must retain all copyright notices contained within.

     You may not sell SMTSIM or distribute SMTSIM in conjunction with a
     commerical product or service without the express written consent of
     Dean Tullsen.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.

Significant parts of the SMTSIM simulator were written by Jack Lo.
Therefore the following copyrights may also apply:

Copyright (C) Jack Lo
 */

#ifndef _PRED_H_DEFINED
#define _PRED_H_DEFINED

typedef enum {PREDICT_WRONG=0, PREDICT_CORRECT=1} broutcome;

/* sizes of the prediction history table and the BTB */

#define PHTSIZE 2048
#define PHTMASK (PHTSIZE-1)
#define BTBSIZE 256
#define BTBASSOC 4
#define BTBMASK ((BTBSIZE/BTBASSOC)-1)

#define TAKEN 1
#define NOT_TAKEN 0
enum { BRANCH, JUMP, RETURN};

#endif _PRED_H_DEFINED
