/* SMTSIM simulator.
   
   Copyright (C) 1994-1999 by Dean Tullsen (tullsen@cs.ucsd.edu)
   ALL RIGHTS RESERVED.

   SMTSIM is distributed under the following conditions:

     You may make copies of SMTSIM for your own use and modify those copies.

     All copies of SMTSIM must retain all copyright notices contained within.

     You may not sell SMTSIM or distribute SMTSIM in conjunction with a
     commerical product or service without the express written consent of
     Dean Tullsen.

   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
   IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
   PURPOSE.

 */

#include "main.h"

scoreboard_t *rread_head;
scoreboard_t *rread_tail;

extern scoreboard_t *exec_head;
extern scoreboard_t *exec_tail;

int num_in_rread;
extern int num_in_exec;

/* Just pass on to the next stage */

void
regread()
{
  num_in_exec += num_in_rread;
  num_in_rread = 0;
  if (!exec_head) {
    exec_head = rread_head;
    exec_tail = rread_tail;
  }
  else {
    exec_tail->next = rread_head;
    exec_tail = rread_tail;
  }
  rread_head = NULL;
  rread_tail = NULL;
}
